## content-hub 0.0+15.04.20141202

=== CMakeLists.txt ===
# Copyright © 2013 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Thomas Voss <thomas.voss@canonical.com>

cmake_minimum_required(VERSION 2.8)

project(content-hub)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

include (GNUInstallDirs)
include (EnableCoverageReport)
include (GSettings)

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror -Wall -pedantic -Wextra -fPIC -pthread")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -Werror -Wall -fno-strict-aliasing -pedantic -Wextra -fPIC -pthread -Wno-unused-function")
set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--no-undefined")

# Workaround for libexecdir on debian
if (EXISTS "/etc/debian_version")
  set(CMAKE_INSTALL_LIBEXECDIR ${CMAKE_INSTALL_LIBDIR})
  set(CMAKE_INSTALL_FULL_LIBEXECDIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBEXECDIR}")
endif()

set(pkglibexecdir "${CMAKE_INSTALL_FULL_LIBEXECDIR}")


#####################################################################
# Enable code coverage calculation with gcov/gcovr/lcov
# Usage:
#  * Switch build type to coverage (use ccmake or cmake-gui)
#  * Invoke make, make test, make coverage
#  * Find html report in subdir coveragereport
#  * Find xml report feasible for jenkins in coverage.xml
#####################################################################
IF(CMAKE_BUILD_TYPE MATCHES [cC][oO][vV][eE][rR][aA][gG][eE])
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -ftest-coverage -fprofile-arcs" )
  SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -ftest-coverage -fprofile-arcs" )
  SET(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -ftest-coverage -fprofile-arcs" )
  SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -ftest-coverage -fprofile-arcs" )
ENDIF(CMAKE_BUILD_TYPE MATCHES [cC][oO][vV][eE][rR][aA][gG][eE])

enable_testing()

set(CMAKE_INCLUDE_CURRENT_DIR ON)

find_package(Qt5Core)
find_package(Qt5DBus)
find_package(PkgConfig REQUIRED)
pkg_check_modules(GLIB REQUIRED glib-2.0)
pkg_check_modules(GIO REQUIRED gio-unix-2.0)
pkg_check_modules(UBUNTU_LAUNCH REQUIRED ubuntu-app-launch-2)
pkg_check_modules(GSETTINGS REQUIRED gsettings-qt)
pkg_check_modules(NIH REQUIRED libnih)
pkg_check_modules(NIH_DBUS REQUIRED libnih-dbus)
pkg_check_modules(DBUS REQUIRED dbus-1)
pkg_check_modules(UBUNTU_DOWNLOAD_MANAGER REQUIRED ubuntu-download-manager-client)
pkg_check_modules(NOTIFY REQUIRED libnotify)

add_definitions(-DDEBUG_ENABLED)

set(GETTEXT_PACKAGE "content-hub")
add_definitions(-DI18N_DOMAIN="${GETTEXT_PACKAGE}")

set(CONTENT_HUB_VERSION_MAJOR 0)
set(CONTENT_HUB_VERSION_MINOR 0)
set(CONTENT_HUB_VERSION_PATCH 1)
set(CONTENT_HUB_VERSION "${CONTENT_HUB_VERSION_MAJOR}.${CONTENT_HUB_VERSION_MINOR}.${CONTENT_HUB_VERSION_PATCH}")

set(QML_API_VERSION_MAJOR 1)

include_directories(include)

file(GLOB_RECURSE I18N_QML_SRC_FILES
     RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}
     import/Ubuntu/Content/**.qml)
list(SORT I18N_QML_SRC_FILES)

file(GLOB_RECURSE I18N_CPP_SRC_FILES
     RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}
     src/com/ubuntu/content/detail/**.cpp)
list(SORT I18N_CPP_SRC_FILES)

# for dh_translations to extract the domain
# (regarding syntax consistency, see http://pad.lv/1181187)
set (GETTEXT_PACKAGE "content-hub")

add_subdirectory(doc)
add_subdirectory(po)
add_subdirectory(src)
add_subdirectory(import)
add_subdirectory(examples)
add_subdirectory(tests)

install(DIRECTORY include DESTINATION ${CMAKE_INSTALL_PREFIX})

# Build and install a pkg-config file
set(prefix ${CMAKE_INSTALL_PREFIX})
set(exec_prefix ${prefix}/bin)
set(libdir ${prefix}/${CMAKE_INSTALL_LIBDIR})
set(pkg-name "libcontent-hub")
configure_file(libcontent-hub.pc.in libcontent-hub.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libcontent-hub.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

# There's no nice way to format this. Thanks CMake.
add_test(LGPL-required
  /bin/sh -c "! grep -rl 'GNU General' ${PROJECT_SOURCE_DIR}/src/client ${PROJECT_SOURCE_DIR}/include/client ${PROJECT_SOURCE_DIR}/src/shared ${PROJECT_SOURCE_DIR}/include/shared"
)
add_test(GPL-required
  /bin/sh -c "! grep -rl 'GNU Lesser' ${PROJECT_SOURCE_DIR}/src/server ${PROJECT_SOURCE_DIR}/include/server ${PROJECT_SOURCE_DIR}/include/test ${PROJECT_SOURCE_DIR}/tests ${PROJECT_SOURCE_DIR}/examples"
)

=== tests/peers/exporter/CMakeLists.txt ===
# Copyright © 2014 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Ken VanDine <ken.vandine@canonical.com>

include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_executable(
  content-hub-test-exporter

  exporter.cpp
  autoexporter.cpp
)

qt5_use_modules(content-hub-test-exporter Core Gui DBus)

set_target_properties(
  content-hub-test-exporter
  PROPERTIES
  AUTOMOC TRUE
)

target_link_libraries(
  content-hub-test-exporter
 
  content-hub 
)

install(
  TARGETS content-hub-test-exporter
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)

install(
  FILES content-hub-test-exporter.json
  DESTINATION ${CMAKE_INSTALL_DATADIR}/content-hub/peers
  RENAME content-hub-test-exporter
)

install(
  FILES content-hub-test-exporter.desktop
  DESTINATION ${CMAKE_INSTALL_DATADIR}/applications
)

install(
  FILES content-hub-test-exporter.png
  DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/512x512/apps/
)

=== src/com/ubuntu/content/CMakeLists.txt ===
# Copyright © 2013 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Thomas Voss <thomas.voss@canonical.com>

add_subdirectory(service)

include_directories(
  ${CMAKE_CURRENT_BINARY_DIR}
  ${CMAKE_SOURCE_DIR}/src
  ${CMAKE_SOURCE_DIR}
  ${CMAKE_SOURCE_DIR}/include
  ${GLIB_INCLUDE_DIRS}
  ${GIO_INCLUDE_DIRS}
  ${NIH_INCLUDE_DIRS}
  ${NIH_DBUS_INCLUDE_DIRS}
  ${UBUNTU_LAUNCH_INCLUDE_DIRS}
  ${UBUNTU_DOWNLOAD_MANAGER_INCLUDE_DIRS}
  ${NOTIFY_INCLUDE_DIRS}
)

qt5_add_dbus_interface(
  CONTENT_SERVICE_STUB ${CMAKE_CURRENT_SOURCE_DIR}/detail/com.ubuntu.content.Service.xml 
  ContentServiceInterface)
qt5_add_dbus_adaptor(
  CONTENT_SERVICE_SKELETON ${CMAKE_CURRENT_SOURCE_DIR}/detail/com.ubuntu.content.Service.xml 
  detail/service.h com::ubuntu::content::detail::Service)

qt5_add_dbus_interface(
  CONTENT_TRANSFER_STUB ${CMAKE_CURRENT_SOURCE_DIR}/detail/com.ubuntu.content.Transfer.xml
  ContentTransferInterface)
qt5_add_dbus_adaptor(
  CONTENT_TRANSFER_SKELETON ${CMAKE_CURRENT_SOURCE_DIR}/detail/com.ubuntu.content.Transfer.xml 
  detail/transfer.h com::ubuntu::content::detail::Transfer)

qt5_add_dbus_interface(
  CONTENT_HANDLER_STUB ${CMAKE_CURRENT_SOURCE_DIR}/detail/com.ubuntu.content.Handler.xml 
  ContentHandlerInterface)
qt5_add_dbus_adaptor(
  CONTENT_HANDLER_SKELETON ${CMAKE_CURRENT_SOURCE_DIR}/detail/com.ubuntu.content.Handler.xml 
  detail/handler.h com::ubuntu::content::detail::Handler)

qt5_wrap_cpp(CONTENT_HUB_MOCS ${CMAKE_SOURCE_DIR}/include/com/ubuntu/content/hub.h)
qt5_wrap_cpp(CONTENT_HUB_MOCS ${CMAKE_SOURCE_DIR}/include/com/ubuntu/content/import_export_handler.h)
qt5_wrap_cpp(CONTENT_HUB_MOCS ${CMAKE_SOURCE_DIR}/include/com/ubuntu/content/item.h)
qt5_wrap_cpp(CONTENT_HUB_MOCS ${CMAKE_SOURCE_DIR}/include/com/ubuntu/content/peer.h)
qt5_wrap_cpp(CONTENT_HUB_MOCS ${CMAKE_SOURCE_DIR}/include/com/ubuntu/content/store.h)
qt5_wrap_cpp(CONTENT_HUB_MOCS ${CMAKE_SOURCE_DIR}/include/com/ubuntu/content/transfer.h)
qt5_wrap_cpp(CONTENT_HUB_MOCS ${CMAKE_SOURCE_DIR}/include/com/ubuntu/content/type.h)

add_library(
  content-hub SHARED

  hub.cpp
  import_export_handler.cpp
  item.cpp
  peer.cpp
  store.cpp
  transfer.cpp
  type.cpp
  utils.cpp
  debug.cpp

  detail/app_manager.cpp
  detail/service.cpp
  detail/transfer.cpp
  detail/handler.cpp
  detail/i18n.cpp

  ${CONTENT_HUB_MOCS}
  ${CONTENT_SERVICE_STUB}
  ${CONTENT_SERVICE_SKELETON}
  ${CONTENT_TRANSFER_STUB}
  ${CONTENT_TRANSFER_SKELETON}
  ${CONTENT_HANDLER_STUB}
  ${CONTENT_HANDLER_SKELETON}
)

set_target_properties(
  content-hub

  PROPERTIES
  VERSION ${CONTENT_HUB_VERSION_MAJOR}.${CONTENT_HUB_VERSION_MINOR}.${CONTENT_HUB_VERSION_PATCH}
  SOVERSION ${CONTENT_HUB_VERSION_MAJOR}
  AUTOMOC TRUE
)

qt5_use_modules(content-hub Core DBus Gui)

target_link_libraries(content-hub
    ${UBUNTU_LAUNCH_LDFLAGS}
    ${NIH_LIBRARIES}
    ${NIH_DBUS_LIBRARIES}
    ${GIO_LIBRARIES}
    ${UBUNTU_DOWNLOAD_MANAGER_LIBRARIES}
    ${NOTIFY_LIBRARIES}
)

install(
  TARGETS content-hub
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

=== src/com/ubuntu/content/service/CMakeLists.txt ===
# Copyright © 2013 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Thomas Voss <thomas.voss@canonical.com>

include_directories(${CMAKE_CURRENT_BINARY_DIR})

qt5_add_dbus_adaptor(
  CONTENT_SERVICE_SKELETON ${CMAKE_SOURCE_DIR}/src/com/ubuntu/content/detail/com.ubuntu.content.Service.xml
  detail/service.h com::ubuntu::content::detail::Service)

include_directories(
  ${CMAKE_SOURCE_DIR}/src
  ${CMAKE_SOURCE_DIR}/src/com/ubuntu/content
  ${GSETTINGS_INCLUDE_DIRS}
  ${UBUNTU_LAUNCH_INCLUDE_DIRS}
)

add_executable(
  content-hub-service

  main.cpp
  registry.cpp
  ../debug.cpp
  ${CONTENT_SERVICE_SKELETON}
)

qt5_use_modules(content-hub-service Core DBus Gui)

target_link_libraries(
  content-hub-service
 
  content-hub
  ${GSETTINGS_LDFLAGS}
  ${UBUNTU_LAUNCH_LDFLAGS}
)

install(
  TARGETS content-hub-service
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)

install(
  FILES com.ubuntu.content.dbus.Service.service 
  DESTINATION ${CMAKE_INSTALL_DATADIR}/dbus-1/services
)

###########################
# GSettings
###########################

add_schema ("com.ubuntu.content.hub.gschema.xml")

add_executable(
  content-hub-peer-hook

  helper.cpp
  registry.cpp
  hook.cpp
)

qt5_use_modules(content-hub-peer-hook Core Gui DBus)

target_link_libraries(
  content-hub-peer-hook
 
  content-hub
  ${GSETTINGS_LDFLAGS}
  ${UBUNTU_LAUNCH_LDFLAGS}
)

configure_file("content-hub-peer-hook-wrapper.in"
  "content-hub-peer-hook-wrapper"
  @ONLY
)

install(
  PROGRAMS "${CMAKE_CURRENT_BINARY_DIR}/content-hub-peer-hook-wrapper"
  DESTINATION "${CMAKE_INSTALL_FULL_LIBEXECDIR}/content-hub"
)

install(
  TARGETS content-hub-peer-hook
  RUNTIME DESTINATION "${CMAKE_INSTALL_FULL_LIBEXECDIR}/content-hub"
)

set_target_properties(
  content-hub-peer-hook
  PROPERTIES
  AUTOMOC TRUE
)

set(CLICK_HOOK
"${CMAKE_CURRENT_BINARY_DIR}/content-hub.hook"
)

configure_file("content-hub.hook.in"
  "${CLICK_HOOK}"
  @ONLY
)

install(
FILES
"${CLICK_HOOK}"
DESTINATION "/usr/share/click/hooks"
)

## content-hub 0.0+15.04.20150319

=== tests/CMakeLists.txt ===
# Copyright © 2013 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Thomas Voss <thomas.voss@canonical.com>

# Build with system gmock and embedded gtest
set (GMOCK_INCLUDE_DIR "/usr/include/gmock/include" CACHE PATH "gmock source include directory")
set (GMOCK_SOURCE_DIR "/usr/src/gmock" CACHE PATH "gmock source directory")
set (GTEST_INCLUDE_DIR "${GMOCK_SOURCE_DIR}/gtest/include" CACHE PATH "gtest source include directory")

add_subdirectory(${GMOCK_SOURCE_DIR} "${CMAKE_CURRENT_BINARY_DIR}/gmock")

include_directories (
  ${CMAKE_SOURCE_DIR}/src
  ${CMAKE_SOURCE_DIR}/src/com/ubuntu/content
  ${UBUNTU_LAUNCH_INCLUDE_DIRS}
  ${CMAKE_BINARY_DIR}/src
  ${GMOCK_INCLUDE_DIR}
  ${GTEST_INCLUDE_DIR}
)

add_subdirectory(acceptance-tests)
add_subdirectory(qml-tests)
add_subdirectory(peers)

## content-hub 0.0+15.04.20150331

=== debian/changelog ===
content-hub (0.0+15.04.20150331-0ubuntu1.0) vivid-security; urgency=medium

  * SECURITY UPDATE: file disclosure via unchecked AppArmor profile
    (LP: #1456628)
    - debian/patches/lp1456628.patch: Don't allow exporting of files that
      aren't allowed by the source apparmor profile
    - CVE-2015-1327

 -- Ken VanDine <ken.vandine@canonical.com>  Mon, 01 Jun 2015 11:17:27 -0400

content-hub (0.0+15.04.20150331-0ubuntu1) vivid; urgency=medium

  [ Ken VanDine ]
  * When requesting an import from an unknown peer, abort the transfer.
    This is most likely to occur when requesting the default peer for a
    ContentType that has no default registered. (LP: #1429695)

 -- CI Train Bot <ci-train-bot@canonical.com>  Tue, 31 Mar 2015 14:10:11 +0000

content-hub (0.0+15.04.20150319-0ubuntu1) vivid; urgency=medium

  [ Ken VanDine ]
  * Abort transfers when a file already exists matching the requested
    name and ContentStore. (LP: #1429687)

 -- CI Train Bot <ci-train-bot@canonical.com>  Thu, 19 Mar 2015 15:27:11 +0000

content-hub (0.0+15.04.20150123-0ubuntu1) vivid; urgency=low

  [ Michael Sheldon ]
  * Use the theme background so that fonts are visible with dark apps
    (LP: #1384490)

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Fri, 23 Jan 2015 16:56:52 +0000

content-hub (0.0+15.04.20141202-0ubuntu1) vivid; urgency=low

  [ Michael Sheldon ]
  * Handle content peer model loading asynchronously (LP: #1390096)

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Tue, 02 Dec 2014 14:17:57 +0000

content-hub (0.0+15.04.20141126-0ubuntu1) vivid; urgency=low

  [ Ken VanDine ]
  * Added test peers for automated testing of export, import and shares.

  [ CI bot ]
  * Resync trunk

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Wed, 26 Nov 2014 15:26:15 +0000

content-hub (0.0+15.04.20141120-0ubuntu1) vivid; urgency=low

  [ Ken VanDine ]
  * Fixed conflict with nih-dbus and our own i18n wrapper (LP: #1394211)

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Thu, 20 Nov 2014 04:22:47 +0000

content-hub (0.0+15.04.20141110-0ubuntu1) vivid; urgency=low

  [ Ken VanDine ]
  * Added EBooks to well known types (LP: #1383732)

  [ CI bot ]
  * Resync trunk

  [ Ubuntu daily release ]
  * New rebuild forced

  [ Michael Sheldon ]
  * Set the caller on the ContentTransferHint dialog to allow it to be
    destroyed safely when its parent is destroyed. (LP: #1377334)
  * Update click hook wrapper to account for change in dbus-session
    file. (LP: #1390095)

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Mon, 10 Nov 2014 16:31:46 +0000

content-hub (0.0+14.10.20141014-0ubuntu1) 14.09; urgency=low

  [ CI bot ]
  * Resync trunk

  [ Ubuntu daily release ]
  * New rebuild forced

  [ Michael Sheldon ]
  * Add support for receiving directories of unzipped files from
    download manager. (LP: #1365993)

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Tue, 14 Oct 2014 16:11:13 +0000

content-hub (0.0+14.10.20141010-0ubuntu1) utopic; urgency=low

  [ Sebastien Bacher ]
  * Include missing sources in the translation template, use the custom
    rule to update it and load the translations from the correct domain

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Fri, 10 Oct 2014 16:16:32 +0000

content-hub (0.0+14.10.20141009-0ubuntu1) utopic; urgency=low

  [ Ken VanDine ]
  * Fall back to a copy if move fails (LP: #1373086)

  [ Michael Sheldon ]
  * Fix packaging for translations.

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Thu, 09 Oct 2014 14:44:05 +0000

content-hub (0.0+14.10.20141007-0ubuntu1) utopic; urgency=low

  [ Sebastien Bacher ]
  * use X-Ubuntu-Use-Langpack so translations are imported (LP:
    #1378324)

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Tue, 07 Oct 2014 14:44:14 +0000

content-hub (0.0+14.10.20140919-0ubuntu1) utopic; urgency=low

  [ Ken VanDine ]
  * Fixed handling of translated strings from
    g_app_info_get_display_name (LP: #1368770) (LP: #1368770)

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Fri, 19 Sep 2014 14:40:29 +0000

content-hub (0.0+14.10.20140915-0ubuntu1) utopic; urgency=low

  [ Ken VanDine ]
  * Build with dh_translations (LP: #1359166) (LP: #1359166)
  * Improved uncreatable message for ContentTransfer

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Mon, 15 Sep 2014 20:50:10 +0000

content-hub (0.0+14.10.20140828-0ubuntu1) utopic; urgency=low

  [ Michael Sheldon ]
  * Expose the source and destination app IDs on transfers.

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Thu, 28 Aug 2014 03:09:56 +0000

content-hub (0.0+14.10.20140815-0ubuntu1) utopic; urgency=low

  [ Michael Sheldon ]
  * Add a cancel button to the ContentTransferHint.

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Fri, 15 Aug 2014 17:49:09 +0000

content-hub (0.0+14.10.20140806.2-0ubuntu1) utopic; urgency=low

  [ Ken VanDine ]
  * Add contentType property to Transfer

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Wed, 06 Aug 2014 20:09:47 +0000

content-hub (0.0+14.10.20140801.4-0ubuntu1) utopic; urgency=medium

  [ Ken VanDine ]
  * debian/control
    - Renamed the binary for the qml module to qtdeclarative5-ubuntu-content1
      to reflect support for API version 1.x instead of 0.1

  [ Michael Sheldon ]
  * Remove the Ubuntu shape from the save icon in the download snap
    decision. (LP: #1350281)
  * Transfer entire content Item objects over dbus, instead of just
    their URL component. Adds name property to C++ backend and connects
    to existing QML property.
  * Ignore unused function warnings (new in g++ 4.9), as utils.cpp
    defines a number of static functions that may not be used
    everywhere.
  * Make the ContentPeerPicker's header text customisable and replace
    the bottom cancel button with new header style cancel.

  [ Ubuntu daily release ]
  * New rebuild forced



=== debian/control ===
Source: content-hub
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Build-Depends: cmake,
               click-dev,
               dbus-test-runner,
               debhelper (>= 9),
               dh-apparmor,
               dh-translations,
               doxygen,
               google-mock,
               lcov,
               libapparmor-dev,
               libglib2.0-dev,
               libgsettings-qt-dev,
               libnih-dbus-dev,
               libnotify-dev,
               libubuntu-download-manager-client-dev,
               libubuntu-app-launch2-dev (>= 0.3+14.04.20140124),
               qt5-default,
               qtbase5-dev,
               qtdeclarative5-dev,
               qtdeclarative5-qtquick2-plugin,
               qtdeclarative5-test-plugin,
Standards-Version: 3.9.4
Section: libs
Homepage: https://launchpad.net/content-hub
# If you aren't a member of ~phablet-team but need to upload packaging changes,
# just go ahead. ~phablet-team will notice and sync up the code again.
Vcs-Bzr: https://code.launchpad.net/~phablet-team/content-hub/trunk
Vcs-Browser: https://bazaar.launchpad.net/~phablet-team/content-hub/trunk/files
X-Ubuntu-Use-Langpack: yes

Package: content-hub
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: content sharing/picking service
 Content sharing/picking infrastructure and service, designed to allow apps to
 securely and efficiently exchange content.
 This package includes the content sharing service.

Package: libcontent-hub0
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends},
Depends: ${misc:Depends},
         ${shlibs:Depends},
Suggests: content-hub
Breaks: gallery-app (<= 0.0.67+13.10.20130924.1-0ubuntu1)
Description: content sharing/picking library
 Content sharing/picking infrastructure and service, designed to allow apps to
 securely and efficiently exchange content.
 This package includes the content sharing libraries.

Package: libcontent-hub-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libcontent-hub0 (= ${binary:Version}),
         ${misc:Depends},
Description: content sharing development files
 All the development headers and libraries for the content hub

Package: qtdeclarative5-ubuntu-content1
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends},
Depends: libcontent-hub0,
         qtdeclarative5-qtquick2-plugin,
         ${misc:Depends},
         ${shlibs:Depends},
Replaces: qtdeclarative5-ubuntu-content0.1 (<= 0.0+14.10.20140710-0ubuntu1)
Provides: qtdeclarative5-ubuntu-content0.1
Breaks: qtdeclarative5-ubuntu-content0.1 (<= 0.0+14.10.20140710-0ubuntu1)
Description: QML binding for libcontent-hub
 QML bindings for libcontent-hub

Package: libcontent-hub-doc
Section: doc
Architecture: all
Depends: libcontent-hub-dev (>= ${source:Version}),
         ${misc:Depends},
Description: Documentation files for libcontent-hub-dev
 Documentation files for the libcontent-hub development

Package: content-hub-testability
Section: libdevel
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: content sharing testability
 Files and utilities needed for automated testing of content-hub

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DPKG_GENSYMBOLS_CHECK_LEVEL=4

%:
	dh $@ --with click,translations --fail-missing -- -B build

override_dh_auto_install:
	dh_auto_install
	dh_apparmor -pcontent-hub-testability --profile-name=content-hub-testability

override_dh_auto_test:
	dbus-test-runner -t make -p "-C" -p "build/tests/acceptance-tests" -p test
	
override_dh_translations:
	make -C po content-hub.pot

## content-hub 0.0+15.10.20150518

=== CMakeLists.txt ===
--- 
+++ 
@@ -103,6 +103,7 @@
 add_subdirectory(import)
 add_subdirectory(examples)
 add_subdirectory(tests)
+add_subdirectory(tools)
 
 install(DIRECTORY include DESTINATION ${CMAKE_INSTALL_PREFIX})

## content-hub 0.0+15.10.20150701

=== tests/acceptance-tests/CMakeLists.txt ===
# Copyright © 2013 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Thomas Voss <thomas.voss@canonical.com>

qt5_wrap_cpp(MOCS test_harness.h)

add_executable(
  app_hub_communication_default_source
  app_hub_communication_default_source.cpp
  ${MOCS}
)

add_executable(
  app_hub_communication_known_sources
  app_hub_communication_known_sources.cpp
  ${MOCS}
)

add_executable(
  app_hub_communication_stores
  app_hub_communication_stores.cpp
  ${MOCS}
)

add_executable(
  app_hub_communication_transfer
  app_hub_communication_transfer.cpp
  ${MOCS}
)

add_executable(
  app_hub_communication_handler
  app_hub_communication_handler.cpp
  ${MOCS}
  transfer_files
)

add_executable(
  test_utils
  test_utils.cpp
)

add_executable(
  test_hook
  test_hook.cpp
  ${MOCS}
  ${CMAKE_SOURCE_DIR}/src/com/ubuntu/content/service/hook.cpp
  ${CMAKE_SOURCE_DIR}/src/com/ubuntu/content/service/registry.cpp
  good.json
  bad.json
  source_all.json
)

qt5_use_modules(app_hub_communication_default_source Core Gui DBus Test)
qt5_use_modules(app_hub_communication_known_sources Core Gui DBus Test)
qt5_use_modules(app_hub_communication_stores Core Gui DBus Test)
qt5_use_modules(app_hub_communication_transfer Core Gui DBus Test)
qt5_use_modules(app_hub_communication_handler Core Gui DBus Test)
qt5_use_modules(test_utils Core Test)
qt5_use_modules(test_hook Core Gui DBus Test)

target_link_libraries(app_hub_communication_stores content-hub gmock gtest gtest_main)
target_link_libraries(app_hub_communication_default_source content-hub gmock gtest gtest_main)
target_link_libraries(app_hub_communication_known_sources content-hub gmock gtest gtest_main)
target_link_libraries(app_hub_communication_stores content-hub gmock gtest gtest_main)
target_link_libraries(app_hub_communication_transfer content-hub gmock gtest gtest_main)
target_link_libraries(app_hub_communication_handler content-hub gmock gtest gtest_main)
target_link_libraries(test_utils content-hub gmock gtest gtest_main)
target_link_libraries(test_hook content-hub gmock gtest gtest_main ${GSETTINGS_LDFLAGS})

add_test(app_hub_communication_default_source app_hub_communication_default_source)
add_test(app_hub_communication_known_sources app_hub_communication_known_sources)
add_test(app_hub_communication_stores app_hub_communication_stores)
add_test(app_hub_communication_transfer app_hub_communication_transfer)
add_test(app_hub_communication_handler app_hub_communication_handler)
add_test(test_utils test_utils)
add_test(test_hook test_hook)

set_target_properties(
  test_hook
  PROPERTIES
  AUTOMOC TRUE
)

file(COPY good.json bad.json source_all.json DESTINATION .)

add_custom_command(
  OUTPUT transfer_files
  COMMAND cmake -E touch file1 file2 file3
)

## content-hub 0.0+15.10.20150821.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -68,6 +68,7 @@
 pkg_check_modules(DBUS REQUIRED dbus-1)
 pkg_check_modules(UBUNTU_DOWNLOAD_MANAGER REQUIRED ubuntu-download-manager-client)
 pkg_check_modules(NOTIFY REQUIRED libnotify)
+pkg_check_modules(APPARMOR REQUIRED libapparmor)
 
 add_definitions(-DDEBUG_ENABLED)

=== tests/peers/data/CMakeLists.txt ===
# Copyright © 2013 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Ken VanDine <ken.vandine@canonical.com>

install(
  FILES webbrowser-app.png clock.png Joker.vcf Stark,_Tony.vcf
  DESTINATION ${CMAKE_INSTALL_DATADIR}/content-hub/testability/data
)

=== src/com/ubuntu/content/CMakeLists.txt ===
--- 
+++ 
@@ -28,6 +28,7 @@
   ${UBUNTU_LAUNCH_INCLUDE_DIRS}
   ${UBUNTU_DOWNLOAD_MANAGER_INCLUDE_DIRS}
   ${NOTIFY_INCLUDE_DIRS}
+  ${APPARMOR_INCLUDE_DIRS}
 )
 
 qt5_add_dbus_interface(
@@ -105,6 +106,7 @@
     ${GIO_LIBRARIES}
     ${UBUNTU_DOWNLOAD_MANAGER_LIBRARIES}
     ${NOTIFY_LIBRARIES}
+    ${APPARMOR_LDFLAGS}
 )
 
 install(

## content-hub 0.0+15.10.20150909

=== import/Ubuntu/Content/CMakeLists.txt ===
# Copyright © 2013 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

project(content-hub-plugin)

find_package(Qt5Quick REQUIRED)
set(CMAKE_AUTOMOC TRUE)

execute_process(
    COMMAND qmake -query QT_INSTALL_QML
    OUTPUT_VARIABLE QT_INSTALL_QML
    OUTPUT_STRIP_TRAILING_WHITESPACE
)
execute_process(
    COMMAND qmake -query QT_INSTALL_BINS
    OUTPUT_VARIABLE QT_INSTALL_BINS
    OUTPUT_STRIP_TRAILING_WHITESPACE
)
set(CONTENT_HUB_IMPORTS_DIR "${QT_INSTALL_QML}/Ubuntu/Content")

set(PLUGIN ubuntu-content-hub-plugin)

add_definitions(-DQT_NO_KEYWORDS)

include_directories(
    ${CMAKE_SOURCE_DIR}
    ${NIH_INCLUDE_DIRS}
    ${NIH_DBUS_INCLUDE_DIRS}
    ${DBUS_INCLUDE_DIRS}
)

set(PLUGIN_HDRS
    contenthandler.h
    contenthub.h
    contenthubplugin.h
    contenticonprovider.h
    contentitem.h
    contentpeer.h
    contentpeermodel.h
    contentscope.h
    contentstore.h
    contenttransfer.h
    contenttype.h
    qmlimportexporthandler.h
    )

set(PLUGIN_SRC
    contenthandler.cpp
    contenthub.cpp
    contenthubplugin.cpp
    contenticonprovider.cpp
    contentitem.cpp
    contentpeer.cpp
    contentpeermodel.cpp
    contentscope.cpp
    contentstore.cpp
    contenttransfer.cpp
    contenttype.cpp
    qmlimportexporthandler.cpp
    ../../../src/com/ubuntu/content/debug.cpp
    )

add_library(${PLUGIN} MODULE ${PLUGIN_SRC} ${PLUGIN_HDRS})

qt5_use_modules(${PLUGIN} Core Qml Quick DBus)
target_link_libraries(
    ${PLUGIN}
    content-hub
    ${NIH_LIBRARIES}
    ${NIH_DBUS_LIBRARIES}
)

install(TARGETS ${PLUGIN} DESTINATION ${CONTENT_HUB_IMPORTS_DIR})
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/qmldir DESTINATION ${CONTENT_HUB_IMPORTS_DIR})

file(GLOB QML_FILES RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.qml qmldir)
install(FILES ${QML_FILES} DESTINATION ${CONTENT_HUB_IMPORTS_DIR})

if(NOT ${CMAKE_CURRENT_BINARY_DIR} STREQUAL ${CMAKE_CURRENT_SOURCE_DIR})
  # copy qml files and assets over to build dir to be able to import them uninstalled
  foreach(_file ${QML_FILES})
    add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${_file}
                       DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/${_file}
                       COMMAND ${CMAKE_COMMAND} -E copy_if_different ${CMAKE_CURRENT_SOURCE_DIR}/${_file} ${CMAKE_CURRENT_BINARY_DIR}/${_file})
  endforeach(_file)
  add_custom_target(copy_files_to_build_dir DEPENDS ${QML_FILES})
  add_dependencies(${PLUGIN} copy_files_to_build_dir)
endif()

add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/plugins.qmltypes
    COMMAND ${QT_INSTALL_BINS}/qmlplugindump -notrelocatable Ubuntu.Content 1.1 ../../ > ${CMAKE_CURRENT_BINARY_DIR}/plugins.qmltypes
    DEPENDS ${PLUGIN}
    WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
)

add_custom_target(Content_generated_files ALL SOURCES ${CMAKE_CURRENT_BINARY_DIR}/plugins.qmltypes)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/plugins.qmltypes DESTINATION ${CONTENT_HUB_IMPORTS_DIR})

=== src/com/ubuntu/content/service/CMakeLists.txt ===
--- 
+++ 
@@ -33,6 +33,7 @@
   main.cpp
   registry.cpp
   ../debug.cpp
+  ../utils.cpp
   ${CONTENT_SERVICE_SKELETON}
 )

## content-hub 0.1+16.04.20151124

=== tests/peers/importer/CMakeLists.txt ===
# Copyright © 2014 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Ken VanDine <ken.vandine@canonical.com>

include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_executable(
  content-hub-test-importer

  importer.cpp
  autoimporter.cpp
)

qt5_use_modules(content-hub-test-importer Core Gui DBus)

set_target_properties(
  content-hub-test-importer
  PROPERTIES
  AUTOMOC TRUE
)

target_link_libraries(
  content-hub-test-importer
 
  content-hub 
)

install(
  TARGETS content-hub-test-importer
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)

install(
  FILES content-hub-test-importer.json
  DESTINATION ${CMAKE_INSTALL_DATADIR}/content-hub/peers
  RENAME content-hub-test-importer
)

install(
  FILES content-hub-test-importer.desktop
  DESTINATION ${CMAKE_INSTALL_DATADIR}/applications
)

install(
  FILES content-hub-test-importer.png
  DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/512x512/apps/
)

## content-hub 0.1+16.04.20160309

=== CMakeLists.txt ===
--- 
+++ 
@@ -62,6 +62,7 @@
 pkg_check_modules(GLIB REQUIRED glib-2.0)
 pkg_check_modules(GIO REQUIRED gio-unix-2.0)
 pkg_check_modules(UBUNTU_LAUNCH REQUIRED ubuntu-app-launch-2)
+pkg_check_modules(LIBERTINE REQUIRED libertine)
 pkg_check_modules(GSETTINGS REQUIRED gsettings-qt)
 pkg_check_modules(NIH REQUIRED libnih)
 pkg_check_modules(NIH_DBUS REQUIRED libnih-dbus)

=== po/CMakeLists.txt ===
project(contenthub-translations)

include(FindGettext)
find_program(GETTEXT_XGETTEXT_EXECUTABLE xgettext)

set(DOMAIN ${GETTEXT_PACKAGE})
set(POT_FILE ${DOMAIN}.pot)
file(GLOB PO_FILES *.po)

add_custom_target(${POT_FILE}
                  COMMAND ${GETTEXT_XGETTEXT_EXECUTABLE} -o ${POT_FILE}
                          -D ${CMAKE_SOURCE_DIR}
                          --from-code=UTF-8
                          --c++ --qt --add-comments=TRANSLATORS
                          --keyword=tr --keyword=tr:1,2
                          --package-name=content-hub
                          --copyright-holder='Canonical Ltd.'
                          ${I18N_QML_SRC_FILES}
                  COMMAND ${GETTEXT_XGETTEXT_EXECUTABLE} -o ${POT_FILE}
                          -D ${CMAKE_SOURCE_DIR}
                          --from-code=UTF-8
                          --c++ --qt --add-comments=TRANSLATORS
                          --keyword=__
                          -j
                          --package-name=content-hub
                          --copyright-holder='Canonical Ltd.'
                          ${I18N_CPP_SRC_FILES})

foreach(PO_FILE ${PO_FILES})
    get_filename_component(LANG ${PO_FILE} NAME_WE)
    gettext_process_po_files(${LANG} ALL PO_FILES ${PO_FILE})
    set(INSTALL_DIR ${CMAKE_INSTALL_LOCALEDIR}/${LANG}/LC_MESSAGES)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${LANG}.gmo
            DESTINATION ${INSTALL_DIR}
            RENAME ${DOMAIN}.mo)
endforeach(PO_FILE)

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -19,11 +19,15 @@
 set (GMOCK_SOURCE_DIR "/usr/src/gmock" CACHE PATH "gmock source directory")
 set (GTEST_INCLUDE_DIR "${GMOCK_SOURCE_DIR}/gtest/include" CACHE PATH "gtest source include directory")
 
+add_definitions(-DQT_NO_KEYWORDS)
+
 add_subdirectory(${GMOCK_SOURCE_DIR} "${CMAKE_CURRENT_BINARY_DIR}/gmock")
 
 include_directories (
   ${CMAKE_SOURCE_DIR}/src
   ${CMAKE_SOURCE_DIR}/src/com/ubuntu/content
+  ${GIO_INCLUDE_DIRS}
+  ${LIBERTINE_INCLUDE_DIRS}
   ${UBUNTU_LAUNCH_INCLUDE_DIRS}
   ${CMAKE_BINARY_DIR}/src
   ${GMOCK_INCLUDE_DIR}

=== doc/qml/CMakeLists.txt ===
# add a target to generate API documentation with qdoc
FIND_PROGRAM(QDOC_EXECUTABLE qdoc)
if(QDOC_EXECUTABLE)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/ubuntu-content-hub.qdocconf.in ${CMAKE_CURRENT_BINARY_DIR}/ubuntu-content-hub.qdocconf @ONLY)
add_custom_target(qmldoc
${QDOC_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/ubuntu-content-hub.qdocconf
WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
COMMENT "Generating QML API documentation with qdoc" VERBATIM
)

# copy stylesheet files into build directory for shadow builds
file(COPY "${CMAKE_CURRENT_SOURCE_DIR}/css"
    DESTINATION ${CMAKE_CURRENT_BINARY_DIR}
    )

install(
  DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html/
  DESTINATION ${CMAKE_INSTALL_DOCDIR}/qml/html
)

add_dependencies(doc qmldoc)

endif(QDOC_EXECUTABLE)

=== examples/exporter/CMakeLists.txt ===
# Copyright © 2013 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Ken VanDine <ken.vandine@canonical.com>

include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_executable(
  exporter

  exporter.cpp
  exampleexporter.cpp
)

qt5_use_modules(exporter Core Gui DBus)

set_target_properties(
  exporter
  PROPERTIES
  AUTOMOC TRUE
)

target_link_libraries(
  exporter
 
  content-hub 
)

=== examples/importer/CMakeLists.txt ===
# Copyright © 2013 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Ken VanDine <ken.vandine@canonical.com>

include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_executable(
  importer

  importer.cpp
  exampleimporter.cpp
  example.cpp
)

qt5_use_modules(importer Core Gui DBus)

set_target_properties(
  importer
  PROPERTIES
  AUTOMOC TRUE
)

target_link_libraries(
  importer
 
  content-hub 
)

=== src/com/CMakeLists.txt ===
# Copyright © 2013 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Thomas Voss <thomas.voss@canonical.com>

add_subdirectory(ubuntu)

=== tests/acceptance-tests/CMakeLists.txt ===
--- 
+++ 
@@ -53,6 +53,11 @@
 )
 
 add_executable(
+  test_types
+  test_types.cpp
+)
+
+add_executable(
   test_hook
   test_hook.cpp
   ${MOCS}
@@ -78,6 +83,7 @@
 target_link_libraries(app_hub_communication_transfer content-hub gmock gtest gtest_main)
 target_link_libraries(app_hub_communication_handler content-hub gmock gtest gtest_main)
 target_link_libraries(test_utils content-hub gmock gtest gtest_main)
+target_link_libraries(test_types content-hub gmock gtest gtest_main)
 target_link_libraries(test_hook content-hub gmock gtest gtest_main ${GSETTINGS_LDFLAGS})
 
 add_test(app_hub_communication_default_source app_hub_communication_default_source)
@@ -86,6 +92,7 @@
 add_test(app_hub_communication_transfer app_hub_communication_transfer)
 add_test(app_hub_communication_handler app_hub_communication_handler)
 add_test(test_utils test_utils)
+add_test(test_types test_types)
 add_test(test_hook test_hook)
 
 set_target_properties(

=== tools/send/CMakeLists.txt ===
# Copyright © 2015 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Ken VanDine <ken.vandine@canonical.com>

include_directories(
  ${CMAKE_CURRENT_BINARY_DIR}
  ${CMAKE_SOURCE_DIR}/src/com/ubuntu/content
  ${UBUNTU_LAUNCH_INCLUDE_DIRS}
)

add_executable(
  content-hub-send

  exporter.cpp
  autoexporter.cpp
  ${CMAKE_SOURCE_DIR}/src/com/ubuntu/content/debug.cpp
)

qt5_use_modules(content-hub-send Core Gui DBus)

set_target_properties(
  content-hub-send
  PROPERTIES
  AUTOMOC TRUE
)

target_link_libraries(
  content-hub-send
 
  content-hub 
  ${UBUNTU_LAUNCH_LDFLAGS}
)

install(
  TARGETS content-hub-send
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)

install(
  FILES content-hub-send.desktop
  DESTINATION ${CMAKE_INSTALL_DATADIR}/applications
)

install(
    FILES content-hub-send.url-dispatcher
    DESTINATION share/url-dispatcher/urls
)

=== import/Ubuntu/Content/CMakeLists.txt ===
--- 
+++ 
@@ -38,6 +38,7 @@
     ${NIH_INCLUDE_DIRS}
     ${NIH_DBUS_INCLUDE_DIRS}
     ${DBUS_INCLUDE_DIRS}
+    ${GLIB_INCLUDE_DIRS}
 )
 
 set(PLUGIN_HDRS
@@ -79,6 +80,7 @@
     content-hub
     ${NIH_LIBRARIES}
     ${NIH_DBUS_LIBRARIES}
+    ${GLIB_LIBRARIES}
 )
 
 install(TARGETS ${PLUGIN} DESTINATION ${CONTENT_HUB_IMPORTS_DIR})

=== tests/peers/exporter/CMakeLists.txt ===
--- 
+++ 
@@ -24,6 +24,7 @@
 )
 
 qt5_use_modules(content-hub-test-exporter Core Gui DBus)
+pkg_check_modules(APPARMOR REQUIRED libapparmor)
 
 set_target_properties(
   content-hub-test-exporter
@@ -35,6 +36,7 @@
   content-hub-test-exporter
  
   content-hub 
+  ${APPARMOR_LDFLAGS}
 )
 
 install(

=== tests/peers/sharer/CMakeLists.txt ===
# Copyright © 2014 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Ken VanDine <ken.vandine@canonical.com>

include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_executable(
  content-hub-test-sharer

  sharer.cpp
  autosharer.cpp
)

qt5_use_modules(content-hub-test-sharer Core Gui DBus)

set_target_properties(
  content-hub-test-sharer
  PROPERTIES
  AUTOMOC TRUE
)

target_link_libraries(
  content-hub-test-sharer
 
  content-hub 
)

install(
  TARGETS content-hub-test-sharer
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)

install(
  FILES content-hub-test-sharer.json
  DESTINATION ${CMAKE_INSTALL_DATADIR}/content-hub/peers
  RENAME content-hub-test-sharer
)

install(
  FILES content-hub-test-sharer.desktop
  DESTINATION ${CMAKE_INSTALL_DATADIR}/applications
)

install(
  FILES content-hub-test-sharer.png
  DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/512x512/apps/
)
